SystemOrganization addCategory: #'Hipay-Core'!

Object subclass: #HPModeBXML
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPModeBXML commentStamp: 'FrancoisStephany 1/27/2012 17:31' prior: 0!
| data sign encoded md5 |

data := HPModeBXML new generateXML.
sign := 'dcdbeea71dacd2b80d59f0c2960a9e4b'.
encoded := (Base64MimeConverter mimeEncode: data readStream) contents.
md5 := MD5 hashMessage: (encoded , sign).
 

Mandatory fields:
GENERAL:
userAccountId
currency
ageGroup
categoryId
locale

PRODUCT DESCRIPTION:
id
name
infos
amount
categoryId
quantity

PRODUCT TAXES:
id
label
amount!

!HPModeBXML methodsFor: 'XML generation' stamp: 'FrancoisStephany 1/27/2012 16:56'!
addItems: seedItems on: root
	| itemsNode |
	itemsNode := XMLElement named: 'items'.
	seedItems doWithIndex: [:each :index | | itemNode |
		itemNode := XMLElement named: 'item'.
		itemNode attributeAt: 'id' put: index printString.
		self addPropertiesOfItem: each on: itemNode.
		itemsNode addElement: itemNode ].
	
	root addElement: itemsNode.! !

!HPModeBXML methodsFor: 'XML generation' stamp: 'FrancoisStephany 1/27/2012 16:25'!
addMandatoryFields: aDictionary on: aNode
	aDictionary keysAndValuesDo: [:key :value |
		aNode addElement: (
			(XMLElement named: key) addContent: (XMLString string: value)).]
! !

!HPModeBXML methodsFor: 'XML generation' stamp: 'FrancoisStephany 1/27/2012 16:54'!
addPropertiesOfItem: anItemDictionary on: itemNode
	anItemDictionary keysAndValuesDo: [:key :value | | property |
		property := (XMLElement named: key) addContent: (XMLString string: value).
		itemNode addElement: property.
	].! !

!HPModeBXML methodsFor: 'accessing' stamp: 'FrancoisStephany 1/27/2012 16:37'!
defaultMandatoryFields
	^Dictionary new
		at: 'userAccountId' put: '87898';
		at: 'currency' put: 'EUR';
		at: 'ageGroup' put: 'ALL';
		at: 'categoryId' put: '564';
		at: 'locale' put: 'fr_FR';
		yourself.! !

!HPModeBXML methodsFor: 'XML generation' stamp: 'FrancoisStephany 1/27/2012 16:39'!
generateXML
	| document root |
	document := XMLDocument new
		version: '1.0';
		encoding: 'UTF-8';
		yourself.
	root := XMLElement named: 'order'.
	
	self addMandatoryFields: self defaultMandatoryFields on: root.
	self addItems: self seedItems on: root.

	document addElement: root.
	^document asString.! !

!HPModeBXML methodsFor: 'accessing' stamp: 'FrancoisStephany 1/27/2012 16:52'!
seedItems
	^OrderedCollection
		with: (Dictionary new
				at: 'name' put: 'Tournai';
				at: 'infos' put: 'Cette fantastique ville';
				at: 'amount' put: '242';
				at: 'categoryId' put: '564';
				at: 'quantity' put: '1';
				yourself)
		with: (Dictionary new
				at: 'name' put: 'Ath';
				at: 'infos' put: 'Cette ville toute pourrie';
				at: 'amount' put: '12';
				at: 'categoryId' put: '564';
				at: 'quantity' put: '3';
				yourself)
		
		




! !

Object subclass: #HPOrder
	instanceVariableNames: 'items data userAccountId currency label ageGroup categoryId urlAcquital urlOk urlKo urlCancel urlInstall urlLogo locale issuerAccountLogin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPOrder methodsFor: 'xml generation' stamp: 'FrancoisStephany 1/29/2012 13:13'!
addFieldsOn: root
	"add all the fields with the pragma 'collectForXML''"
	(Pragma allNamed: #collectForXML in: self class) do: [ :each | | key value |
		key = each select asString.
		value := self perform: each selector.
		value isEmptyOrNil ifFalse: [
			root addElement: ((XMLElement named: key) addContent: (XMLString string: value))
		]
	].! !

!HPOrder methodsFor: 'items' stamp: 'FrancoisStephany 1/29/2012 12:40'!
addItem: anHPOrderItem
	self items add: anHPOrderItem.! !

!HPOrder methodsFor: 'xml generation' stamp: 'FrancoisStephany 1/29/2012 13:27'!
addItemsOn: root
	| itemsNode |
	self items isEmpty ifTrue: [ ^self ].
	itemsNode := XMLElement named: 'items'.
	
	self items doWithIndex: [:each :index |
		itemsNode addElement: (each generateXMLElementWithId: index)].
	
	root addElement: itemsNode.! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
ageGroup
	^ ageGroup! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
ageGroup: anObject
	ageGroup := anObject! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
categoryId
	^ categoryId! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
categoryId: anObject
	categoryId := anObject! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
currency
	^ currency! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
currency: anObject
	currency := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
data
	^ data! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
data: anObject
	data := anObject! !

!HPOrder methodsFor: 'xml generation' stamp: 'FrancoisStephany 1/29/2012 12:54'!
generateXML
	| document root |
	document := XMLDocument new
		version: '1.0';
		encoding: 'UTF-8';
		yourself.
	root := XMLElement named: 'order'.
	
	self addFieldsOn: root.
	self addItemsOn: root.

	document addElement: root.
	^document asString.! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
issuerAccountLogin
	<collectForXML>
	^ issuerAccountLogin! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
issuerAccountLogin: anObject
	issuerAccountLogin := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:41'!
items
	" items in the order."
	^ items ifNil: [ items := OrderedCollection new ].! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
items: anObject
	items := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
label
	<collectForXML>
	^ label! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
label: anObject
	label := anObject! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
locale
	^ locale! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
locale: anObject
	locale := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
urlAcquital
	<collectForXML>
	^ urlAcquital! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlAcquital: anObject
	urlAcquital := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
urlCancel
	<collectForXML>
	^ urlCancel! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlCancel: anObject
	urlCancel := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
urlInstall
	<collectForXML>
	^ urlInstall! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlInstall: anObject
	urlInstall := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
urlKo
	<collectForXML>
	^ urlKo! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlKo: anObject
	urlKo := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:13'!
urlLogo
	<collectForXML>
	^ urlLogo! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlLogo: anObject
	urlLogo := anObject! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:14'!
urlOk
	<collectForXML>
	^ urlOk! !

!HPOrder methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:26'!
urlOk: anObject
	urlOk := anObject! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
userAccountId
	^ userAccountId! !

!HPOrder methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:26'!
userAccountId: anObject
	userAccountId := anObject! !

Object subclass: #HPOrderItem
	instanceVariableNames: 'taxes name infos amount categoryId quantity reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPOrderItem methodsFor: 'xml generation' stamp: 'FrancoisStephany 1/29/2012 13:25'!
addFieldsOn: root
	"add all the fields with the pragma 'collectForXML''"
	(Pragma allNamed: #collectForXML in: self class) do: [ :each | | key value |
		key = each select asString.
		value := self perform: each selector.
		value isEmptyOrNil ifFalse: [
			root addElement: ((XMLElement named: key) addContent: (XMLString string: value))
		]
	].! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 13:25'!
amount
	<collectForXML>
	^ amount! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:29'!
amount: anObject
	amount := anObject! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 13:25'!
categoryId
	<collectForXML>
	^ categoryId! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:29'!
categoryId: anObject
	categoryId := anObject! !

!HPOrderItem methodsFor: 'xml generation' stamp: 'FrancoisStephany 1/29/2012 13:26'!
generateXMLElementWithId: anId
	| node |
	node := XMLElement named: 'order'.
	node attributeAt: 'id' put: anId printString.
	self addFieldsOn: node.
	^node! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 13:25'!
infos
	<collectForXML>
	^ infos! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:29'!
infos: anObject
	infos := anObject! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 13:26'!
name
	<collectForXML>
	^ name! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:29'!
name: anObject
	name := anObject! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 13:26'!
quantity
	<collectForXML>
	^ quantity! !

!HPOrderItem methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:29'!
quantity: anObject
	quantity := anObject! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 13:25'!
reference
	<collectForXML>
	^ reference! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:29'!
reference: anObject
	reference := anObject! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:31'!
taxes
	^taxes! !

!HPOrderItem methodsFor: 'accessing' stamp: 'FrancoisStephany 1/29/2012 12:31'!
taxes: aCollectionOfTaxes
	taxes := aCollectionOfTaxes! !

Object subclass: #HPTaxes
	instanceVariableNames: 'id label amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPTaxes methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:31'!
amount
	^ amount! !

!HPTaxes methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:31'!
amount: anObject
	amount := anObject! !

!HPTaxes methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:31'!
id
	^ id! !

!HPTaxes methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:31'!
id: anObject
	id := anObject! !

!HPTaxes methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:31'!
label
	^ label! !

!HPTaxes methodsFor: 'accessing mandatory' stamp: 'FrancoisStephany 1/29/2012 12:31'!
label: anObject
	label := anObject! !

WAComponent subclass: #HPTestComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hipay-Core'!

!HPTestComponent class methodsFor: 'as yet unclassified' stamp: 'FrancoisStephany 1/27/2012 17:30'!
initialize
	"self initialize"
	super initialize.
	WAAdmin register: self asApplicationAt: 'hipay-test'! !

!HPTestComponent methodsFor: 'as yet unclassified' stamp: 'FrancoisStephany 1/27/2012 18:33'!
renderContentOn: html
	| data key signMD5 encodedData |
	
	data := HPModeBXML new generateXML.
	key := 'dcdbeea71dacd2b80d59f0c2960a9e4b'.

	encodedData := (Base64MimeConverter mimeEncode: data readStream multiLine: false) contents.
	signMD5 := (MD5 hashMessage: (encodedData , key)) hex.
	
	html heading level: 1; with: 'HiPay Ta Mre !!'.
	html form
		action: 'https://test-payment.hipay.com/index/form/';
		with: [
			html hiddenInput 
				name: 'mode'; 
				value: 'MODE_B'.
			html hiddenInput
				name: 'website_id';
				value: '3497'.
			html hiddenInput
				name: 'sign';
				value: signMD5.
			html hiddenInput
				name: 'data';
				value: encodedData.
				
			html submitButton.
	]! !
HPTestComponent initialize!
